package com.kexun.annotation;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
  * Description:自定义注解 目标是标注Java实体类字段对应的xml节点
  * @author lgs
  * @date 2023/05/29
  */
@Target(ElementType.FIELD)
@Retention(RetentionPolicy.RUNTIME)
public @interface CrXmlSign {
    /**
     * xmlNode:标识xml节点的name属性
     * @return
     */
    String xmlNodeName() default "";

    /**
     * 报文节点数据类型，主要处理特殊类型
     * @return
     */
    String xmlType() default "String";


}
