package com.kexun.controller;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.kexun.common.utils.Result;
import com.kexun.entity.BusInfoModifyHis;
import com.kexun.entity.CooperatorInfo;
import com.kexun.entity.FieldDefineEntity;
import com.kexun.entity.FieldTemplateEntity;
import com.kexun.hander.PageBean;
import com.kexun.model.ro.FiledRO;
import com.kexun.model.ro.FiledUpdateRO;
import com.kexun.service.CooperatorService;
import com.kexun.service.FieldDefineService;
import com.kexun.utils.PageUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.*;

import java.util.Iterator;
import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;

/**
 * <p>
 * 字段定义表 前端控制器
 * </p>
 *
 * @author lgs
 * @since 2023-06-21
 */
@RestController
@RequestMapping("/admin/")
public class FieldDefineController {

    @Autowired
    private com.kexun.service.FieldDefineService fieldDefineService;
    /**
     * 字段信息读取
     *
     * @return
     */
//    @GetMapping("fieldListNew")
//    public Result fieldListNew() {
//        JSONObject resJson=new JSONObject();
//        List<FieldDefineEntity> list= fieldDefineService.list();
//        resJson.put("fieldListNew",list);
//
//        return Result.success("ok",resJson);
//    }

    @RequestMapping("/fieldListNew")
    @ResponseBody
    public Result findAll(@RequestBody String json){
        JSONObject req = JSON.parseObject(json);
        int pageNum = req.getIntValue("pageNum");
        int pageSize = req.getIntValue("pageSize");
        PageHelper.startPage(pageNum, pageSize);//设置分页信息
        List<FieldDefineEntity> list = fieldDefineService.selectPage();

        List<FieldDefineEntity> list2 = fieldDefineService.selectPage2();

        PageInfo pageInfo=new PageInfo(list);
        PageInfo pageInfo2=new PageInfo(list2);

        JSONObject resJson = new JSONObject();

        resJson.put("fieldListNew", pageInfo);


        resJson.put("fieldListDerive", pageInfo2);

        return Result.success("ok", resJson);
    }

    @RequestMapping("/fieldListBase")
    @ResponseBody
    public Result fieldListBase(@RequestBody String json){
        JSONObject req = JSON.parseObject(json);
        int pageNum = req.getIntValue("pageNum");
        int pageSize = req.getIntValue("pageSize");
        PageHelper.startPage(pageNum, pageSize);//设置分页信息
        List<FieldDefineEntity> list = fieldDefineService.selectPage();
        PageInfo pageInfo=new PageInfo(list);
        JSONObject resJson = new JSONObject();
        resJson.put("fieldListBase", pageInfo);
        return Result.success("ok", resJson);
    }

    @RequestMapping("/selectFieldListBase")
    public Result selectFieldListBase(@RequestBody String json){
        JSONObject req = JSON.parseObject(json);
        int pageNum = req.getIntValue("pageNum");
        int pageSize = req.getIntValue("pageSize");
        String nameZh = req.getString("nameZh");

        PageHelper.startPage(pageNum, pageSize);//设置分页信息
        List<FieldDefineEntity> list = fieldDefineService.selectBase(nameZh);
        PageInfo pageInfo=new PageInfo(list);
        JSONObject resJson = new JSONObject();
        resJson.put("selectFieldListBase", pageInfo);
        return Result.success("ok", resJson);
    }

    @RequestMapping("/fieldListDerive")
    @ResponseBody
    public Result fieldListDerive(@RequestBody String json){
        JSONObject req = JSON.parseObject(json);
        int pageNum = req.getIntValue("pageNum");
        int pageSize = req.getIntValue("pageSize");
        PageHelper.startPage(pageNum, pageSize);//设置分页信息
        List<FieldDefineEntity> list2 = fieldDefineService.selectPage2();
        PageInfo pageInfo2=new PageInfo(list2);
        JSONObject resJson = new JSONObject();
        resJson.put("fieldListDerive", pageInfo2);
        return Result.success("ok", resJson);
    }

    @RequestMapping("/selectFieldListDerive")
    public Result selectFieldListDerive(@RequestBody String json){
        JSONObject req = JSON.parseObject(json);
        int pageNum = req.getIntValue("pageNum");
        int pageSize = req.getIntValue("pageSize");
        String nameZh = req.getString("nameZh");

        PageHelper.startPage(pageNum, pageSize);//设置分页信息
        List<FieldDefineEntity> list = fieldDefineService.selectDerive(nameZh);
        PageInfo pageInfo=new PageInfo(list);
        JSONObject resJson = new JSONObject();
        resJson.put("selectFieldListDerive", pageInfo);
        return Result.success("ok", resJson);
    }
    /**
     * 字段列表查询
     *
     * @return
     */
    @GetMapping("filed-list")
    public Result list(FiledRO filedRO) {
        Result result = new Result();
        PageBean<BusInfoModifyHis> page = new PageBean<>(PageUtils.getPageNo(filedRO.getPageNo()), PageUtils.getPageSize(filedRO.getPageSize()));
        if (StringUtils.isEmpty(filedRO.getCategory())) {
            return Result.error("-1", "字段类别不能为空");
        }
        IPage<FieldDefineEntity> fieldDefineEntityIPage = fieldDefineService.listPage(filedRO);
        result.setData(fieldDefineEntityIPage);
        return result;
    }

    /**
     * 字段列表详情
     *
     * @param id :字段列表主键
     * @return
     */
    @GetMapping("filed-detail")
    public Result detail(@RequestParam Long id) {
        Result result = new Result();
        if (StringUtils.isEmpty(id)) {
            return Result.error("-1", "字段定义的ID不能为空");
        }
        FieldDefineEntity fieldDefineEntity = fieldDefineService.getById(id);
        result.setData(fieldDefineEntity);
        return result;
    }

    /**
     * 保存或者修改字段定义信息
     * @param filedUpdateRO
     * @return
     */
    @PostMapping("filed-update")
    public Result saveOrUpdate(@RequestBody FiledUpdateRO filedUpdateRO){
        fieldDefineService.saveOrUpdate(filedUpdateRO);
        return Result.success();
    }

    /**
     * 基础字段删除
     * @param id 主键ID
     * @return
     */
    @DeleteMapping("filed-delete")
    public Result delete(@RequestParam Long id){
        if (StringUtils.isEmpty(id)) {
            return Result.error("-1", "字段定义的ID不能为空");
        }
        fieldDefineService.removeById(id);
        return Result.success();
    }

    /**
     * 基础字段启用/停用
     * @param id 主键
     * @param status 开启关闭状态
     * @return
     */
    @PostMapping("filed-onoff")
    public Result onOff(@RequestParam Long id,@RequestParam String status){
        if (StringUtils.isEmpty(id)) {
            return Result.error("-1", "字段定义的ID不能为空");
        }
        if (StringUtils.isEmpty(status)) {
            return Result.error("-1", "开启/停用状态不能为空");
        }
        fieldDefineService.updateOnOff(id,status);
        return Result.success();
    }


}
