package com.kexun.entity;

import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.kexun.entity.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 低保救助记录
 * </p>
 *
 * @author lgs
 * @since 2023-06-13
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("cr_pub_allow_anc")
@ApiModel(value="PubAllowAncEntity对象", description="低保救助记录")
public class PubAllowAncEntity extends BaseEntity {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "报告头信息表id")
    @TableField("head_inf_id")
    private Long headInfId;

    @ApiModelProperty(value = "报告编码")
    @TableField("rpt_no")
    private String rptNo;

    @ApiModelProperty(value = "姓名")
    @TableField("name")
    private String name;

    @ApiModelProperty(value = "证件号码")
    @TableField("id_num")
    private String idNum;

    @ApiModelProperty(value = "人员类别代码")
    @TableField("per_type_code")
    private String perTypeCode;

    @ApiModelProperty(value = "人员类别描述")
    @TableField("per_type_desc")
    private String perTypeDesc;

    @ApiModelProperty(value = "所在地代码")
    @TableField("address_code")
    private String addressCode;

    @ApiModelProperty(value = "所在地描述")
    @TableField("address_desc")
    private String addressDesc;

    @ApiModelProperty(value = "工作单位")
    @TableField("work_unit")
    private String workUnit;

    @ApiModelProperty(value = "家庭月收入")
    @TableField("family_income")
    private BigDecimal familyIncome;

    @ApiModelProperty(value = "申请日期")
    @TableField("apply_date")
    private String applyDate;

    @ApiModelProperty(value = "批准日期")
    @TableField("approve_date")
    private String approveDate;

    @ApiModelProperty(value = "信息更新日期")
    @TableField("updatedate")
    private String updatedate;


}
