package com.kexun.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.kexun.entity.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 执业资格记录
 * </p>
 *
 * @author lgs
 * @since 2023-06-13
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("cr_pub_practising")
@ApiModel(value="PubPractisingEntity对象", description="执业资格记录")
public class PubPractisingEntity extends BaseEntity {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "报告头信息表id")
    @TableField("head_inf_id")
    private Long headInfId;

    @ApiModelProperty(value = "报告编码")
    @TableField("rpt_no")
    private String rptNo;

    @ApiModelProperty(value = "姓名")
    @TableField("name")
    private String name;

    @ApiModelProperty(value = "证件号码")
    @TableField("id_num")
    private String idNum;

    @ApiModelProperty(value = "执业资格名称")
    @TableField("pract_name")
    private String practName;

    @ApiModelProperty(value = "颁发机构")
    @TableField("issuer")
    private String issuer;

    @ApiModelProperty(value = "等级代码")
    @TableField("level_code")
    private String levelCode;

    @ApiModelProperty(value = "等级描述")
    @TableField("level_desc")
    private String levelDesc;

    @ApiModelProperty(value = "机构所在地代码")
    @TableField("ins_location_code")
    private String insLocationCode;

    @ApiModelProperty(value = "机构所在地描述")
    @TableField("ins_location_desc")
    private String insLocationDesc;

    @ApiModelProperty(value = "获得日期")
    @TableField("get_date")
    private String getDate;

    @ApiModelProperty(value = "到期日期")
    @TableField("expire_date")
    private String expireDate;

    @ApiModelProperty(value = "吊销日期")
    @TableField("revoke_date")
    private String revokeDate;


}
