package com.kexun.entity;

import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.kexun.entity.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 相关还款责任信息
 * </p>
 *
 * @author lgs
 * @since 2023-06-12
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("cr_rlt_repay_base")
@ApiModel(value="RltRepayBaseEntity对象", description="相关还款责任信息")
public class RltRepayBaseEntity extends BaseEntity {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "报告头信息表id")
    @TableField("head_inf_id")
    private Long headInfId;

    @ApiModelProperty(value = "报告编码")
    @TableField("rpt_no")
    private String rptNo;

    @ApiModelProperty(value = "姓名")
    @TableField("name")
    private String name;

    @ApiModelProperty(value = "证件号码")
    @TableField("id_num")
    private String idNum;

    @ApiModelProperty(value = "记录编号")
    @TableField("account_no")
    private String accountNo;

    @ApiModelProperty(value = "主借款人身份类别代码")
    @TableField("main_id_type")
    private String mainIdType;

    @ApiModelProperty(value = "主借款人身份类别描述")
    @TableField("main_id_no")
    private String mainIdNo;

    @ApiModelProperty(value = "业务管理机构类型代码")
    @TableField("manage_org_type_code")
    private String manageOrgTypeCode;

    @ApiModelProperty(value = "业务管理机构类型描述")
    @TableField("manage_org_type_desc")
    private String manageOrgTypeDesc;

    @ApiModelProperty(value = "业务管理机构")
    @TableField("busi_org_name")
    private String busiOrgName;

    @ApiModelProperty(value = "业务种类代码")
    @TableField("busi_lines_code")
    private String busiLinesCode;

    @ApiModelProperty(value = "业务种类描述")
    @TableField("busi_lines_desc")
    private String busiLinesDesc;

    @ApiModelProperty(value = "开立日期")
    @TableField("open_date")
    private String openDate;

    @ApiModelProperty(value = "到期日期")
    @TableField("due_date")
    private String dueDate;

    @ApiModelProperty(value = "相关还款责任人类型代码")
    @TableField("arlp_type_code")
    private String arlpTypeCode;

    @ApiModelProperty(value = "相关还款责任人类型描述")
    @TableField("arlp_type_desc")
    private String arlpTypeDesc;

    @ApiModelProperty(value = "保证合同编号")
    @TableField("guar_con_num")
    private String guarConNum;

    @ApiModelProperty(value = "相关还款责任金额")
    @TableField("rpy_res_amt")
    private BigDecimal rpyResAmt;

    @ApiModelProperty(value = "币种代码")
    @TableField("currency_code")
    private String currencyCode;

    @ApiModelProperty(value = "币种描述")
    @TableField("currency_desc")
    private String currencyDesc;

    @ApiModelProperty(value = "余额")
    @TableField("balance")
    private BigDecimal balance;

    @ApiModelProperty(value = "五级分类代码")
    @TableField("five_cate_code")
    private String fiveCateCode;

    @ApiModelProperty(value = "五级分类描述")
    @TableField("five_cate_desc")
    private String fiveCateDesc;

    @ApiModelProperty(value = "账户类型代码")
    @TableField("acc_type_code")
    private String accTypeCode;

    @ApiModelProperty(value = "账户类型描述")
    @TableField("acc_type_desc")
    private String accTypeDesc;

    @ApiModelProperty(value = "还款状态代码")
    @TableField("rpy_status_code")
    private String rpyStatusCode;

    @ApiModelProperty(value = "还款状态描述")
    @TableField("rpy_status_desc")
    private String rpyStatusDesc;

    @ApiModelProperty(value = "逾期月数")
    @TableField("overdue_month")
    private Integer overdueMonth;

    @ApiModelProperty(value = "信息报告日期")
    @TableField("report_date")
    private String reportDate;


}
