package com.kexun.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import com.kexun.entity.CooperatorInfo;
import com.kexun.entity.CooperatorProduct;
import com.kexun.entity.FieldDefineEntity;
import com.kexun.model.ro.FiledRO;
import com.kexun.model.ro.FiledUpdateRO;

import java.util.List;

/**
 * <p>
 * 字段定义表 服务类
 * </p>
 *
 * @author lgs
 * @since 2023-06-21
 */
public interface FieldDefineService extends IService<FieldDefineEntity> {

    /**
     * 根据查询条件分页查询字段定义
     * @param filedRO
     * @return
     */
    IPage<FieldDefineEntity> listPage(FiledRO filedRO);

    /**
     * 保存或者修改字段定义信息
     * @param filedUpdateRO
     */
    void saveOrUpdate(FiledUpdateRO filedUpdateRO);

    /**
     * 修改字段类型状态
     * @param id
     * @param status
     */
    void updateOnOff(Long id,String status);

    /**
     * 根据类别查询基础字段定义
     * @param oneLevel
     * @param category
     * @return
     */
    List<FieldDefineEntity> listFieldInfoByLevel(String oneLevel,String category);

    /**
     * 获取所有的衍生字段信息列表
     * @param category 类别
     * @param productNum 产品编号
     * @return
     */
    List<FieldDefineEntity> listFieldDevidPrdField(String productNum, String category);

    /**
     * 根据产品编号字段类别查询字段定义
     * @param productNum 产品编号
     * @param oneLevel   字段定义节点
     * @param category   类别
     * @return
     */
    List<FieldDefineEntity> queryFieldDefineByProd(String productNum,String oneLevel,String category);


    FieldDefineEntity findByID(long id);


    List<FieldDefineEntity> selectPage();

    List<FieldDefineEntity> selectBase(String info);


    List<FieldDefineEntity> selectPage2();

    List<FieldDefineEntity> selectDerive(String info);


}
