package com.kexun.service.xml;

import com.kexun.entity.SmryRecoveredDetailEntity;
import com.kexun.entity.SmryRecoveredEntity;
import com.kexun.model.dto.CommonParam;
import com.kexun.model.xml.IXmlBase;
import com.kexun.model.xml.SmryRecovered;
import com.kexun.model.xml.SmryRecoveredInf;
import com.kexun.model.xml.SmryRecoveredList;
import com.kexun.service.SmryRecoveredDetailService;
import com.kexun.service.SmryRecoveredService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * Description:被追偿信息汇总
 *
 * @author lgs
 * @date 2023/06/07
 */
@Service
public class SmryRecoveredHandlerService implements IHandleXmlBaseService {

    @Autowired
    SmryRecoveredService smryRecoveredService;

    @Autowired
    SmryRecoveredDetailService smryRecoveredDetailService;

    @Override
    public void handleXmlSgmt(CommonParam commonParam, IXmlBase reportXmlBase) {
        if (reportXmlBase instanceof SmryRecovered) {
            SmryRecovered smryRecovered = (SmryRecovered) reportXmlBase;
            SmryRecoveredEntity smryRecoveredEntity = new SmryRecoveredEntity();
            BeanUtils.copyProperties(smryRecovered, smryRecoveredEntity);
            smryRecoveredEntity.setHeadInfId(commonParam.getHeadInfId());
            smryRecoveredEntity.setIdNum(commonParam.getIdNum());
            smryRecoveredEntity.setName(commonParam.getName());
            smryRecoveredEntity.setRptNo(commonParam.getRptNo());
            smryRecoveredService.save(smryRecoveredEntity);
            Long id = smryRecoveredEntity.getId();
            SmryRecoveredList smryRecoveredList = smryRecovered.getSmryRecoveredList();
            if (null != smryRecoveredList) {
                List<SmryRecoveredInf> smryRecoveredInfList = smryRecoveredList.getSmryRecoveredInfList();
                List<SmryRecoveredDetailEntity> smryRecoveredDetailEntitieList = new ArrayList<>();
                for (SmryRecoveredInf smryRecoveredInf : smryRecoveredInfList) {
                    SmryRecoveredDetailEntity smryRecoveredDetailEntity = new SmryRecoveredDetailEntity();

                    BeanUtils.copyProperties(smryRecoveredInf, smryRecoveredDetailEntity);
                    smryRecoveredDetailEntity.setRptNo(commonParam.getRptNo());
                    smryRecoveredDetailEntity.setHeadInfId(commonParam.getHeadInfId());
                    smryRecoveredDetailEntity.setSmryRecoveredId(id);
                    smryRecoveredDetailEntitieList.add(smryRecoveredDetailEntity);
                }
                smryRecoveredDetailService.saveBatch(smryRecoveredDetailEntitieList);
            }
        }

    }
}
