package com.kexun.service.xml;

import com.kexun.entity.SmryTradeTipsDetailEntity;
import com.kexun.entity.SmryTradeTipsEntity;
import com.kexun.model.dto.CommonParam;
import com.kexun.model.xml.SmryTradeTipsInfo;
import com.kexun.model.xml.SmryTradeTipsList;
import com.kexun.model.xml.IXmlBase;
import com.kexun.model.xml.SmryTradeTips;
import com.kexun.service.SmryTradeTipsDetailService;
import com.kexun.service.SmryTradeTipsService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * Description:信息概要. 2.1 信贷交易信息提示
 *
 * @author lgs
 * @date 2023/06/07
 */
@Service
@Slf4j
public class SmryTradeTipsHandlerService implements IHandleXmlBaseService {

    @Autowired
    SmryTradeTipsService smryTradeTipsService;

    @Autowired
    SmryTradeTipsDetailService smryTradeTipsDetailService;

    @Override
    public void handleXmlSgmt(CommonParam commonParam, IXmlBase reportXmlBase) {
        if (reportXmlBase instanceof SmryTradeTips) {
            SmryTradeTips smryTradeTips = (SmryTradeTips) reportXmlBase;
            SmryTradeTipsEntity smryTradeTipsEntity = new SmryTradeTipsEntity();
            BeanUtils.copyProperties(smryTradeTips, smryTradeTipsEntity);
            smryTradeTipsEntity.setHeadInfId(commonParam.getHeadInfId());
            smryTradeTipsEntity.setIdNum(commonParam.getIdNum());
            smryTradeTipsEntity.setName(commonParam.getName());
            smryTradeTipsEntity.setRptNo(commonParam.getRptNo());
            smryTradeTipsService.save(smryTradeTipsEntity);
            Long id = smryTradeTipsEntity.getId();
            //保存信贷交易信息提示-汇总
            SmryTradeTipsList smryTradeTipsList = smryTradeTips.getSmryTradeTipsList();
            if (smryTradeTipsList != null) {
                //信贷交易信息提示-明细
                List<SmryTradeTipsInfo> smryTradeTipsInfo = smryTradeTipsList.getSmryTradeTipsInfo();
                List<SmryTradeTipsDetailEntity> smryTradeTipsDetailEntityList = new ArrayList<>();
                for (SmryTradeTipsInfo tipsInfo : smryTradeTipsInfo) {
                    SmryTradeTipsDetailEntity smryTradeTipsDetailEntity = new SmryTradeTipsDetailEntity();
                    BeanUtils.copyProperties(tipsInfo, smryTradeTipsDetailEntity);
                    smryTradeTipsDetailEntity.setRptNo(commonParam.getRptNo());
                    smryTradeTipsDetailEntity.setHeadInfId(commonParam.getHeadInfId());
                    smryTradeTipsDetailEntity.setSmryTradeTipsId(id);
                    smryTradeTipsDetailEntityList.add(smryTradeTipsDetailEntity);
                }
                smryTradeTipsDetailService.saveBatch(smryTradeTipsDetailEntityList);
            }
        }

    }
}
